// Generated by gencpp from file kombos_server/matrixMsg.msg
// DO NOT EDIT!


#ifndef KOMBOS_SERVER_MESSAGE_MATRIXMSG_H
#define KOMBOS_SERVER_MESSAGE_MATRIXMSG_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace kombos_server
{
template <class ContainerAllocator>
struct matrixMsg_
{
  typedef matrixMsg_<ContainerAllocator> Type;

  matrixMsg_()
    : name()
    , cols(0)
    , rows(0)
    , M()  {
    }
  matrixMsg_(const ContainerAllocator& _alloc)
    : name(_alloc)
    , cols(0)
    , rows(0)
    , M(_alloc)  {
  (void)_alloc;
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _name_type;
  _name_type name;

   typedef int32_t _cols_type;
  _cols_type cols;

   typedef int32_t _rows_type;
  _rows_type rows;

   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _M_type;
  _M_type M;





  typedef boost::shared_ptr< ::kombos_server::matrixMsg_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::kombos_server::matrixMsg_<ContainerAllocator> const> ConstPtr;

}; // struct matrixMsg_

typedef ::kombos_server::matrixMsg_<std::allocator<void> > matrixMsg;

typedef boost::shared_ptr< ::kombos_server::matrixMsg > matrixMsgPtr;
typedef boost::shared_ptr< ::kombos_server::matrixMsg const> matrixMsgConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::kombos_server::matrixMsg_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::kombos_server::matrixMsg_<ContainerAllocator> >::stream(s, "", v);
return s;
}


template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator==(const ::kombos_server::matrixMsg_<ContainerAllocator1> & lhs, const ::kombos_server::matrixMsg_<ContainerAllocator2> & rhs)
{
  return lhs.name == rhs.name &&
    lhs.cols == rhs.cols &&
    lhs.rows == rhs.rows &&
    lhs.M == rhs.M;
}

template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator!=(const ::kombos_server::matrixMsg_<ContainerAllocator1> & lhs, const ::kombos_server::matrixMsg_<ContainerAllocator2> & rhs)
{
  return !(lhs == rhs);
}


} // namespace kombos_server

namespace ros
{
namespace message_traits
{





template <class ContainerAllocator>
struct IsFixedSize< ::kombos_server::matrixMsg_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::kombos_server::matrixMsg_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::kombos_server::matrixMsg_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::kombos_server::matrixMsg_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::kombos_server::matrixMsg_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::kombos_server::matrixMsg_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::kombos_server::matrixMsg_<ContainerAllocator> >
{
  static const char* value()
  {
    return "8c1e478c7b06e7c44dca810a05c98a22";
  }

  static const char* value(const ::kombos_server::matrixMsg_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x8c1e478c7b06e7c4ULL;
  static const uint64_t static_value2 = 0x4dca810a05c98a22ULL;
};

template<class ContainerAllocator>
struct DataType< ::kombos_server::matrixMsg_<ContainerAllocator> >
{
  static const char* value()
  {
    return "kombos_server/matrixMsg";
  }

  static const char* value(const ::kombos_server::matrixMsg_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::kombos_server::matrixMsg_<ContainerAllocator> >
{
  static const char* value()
  {
    return "string name\n"
"int32 cols\n"
"int32 rows\n"
"float64[] M\n"
;
  }

  static const char* value(const ::kombos_server::matrixMsg_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::kombos_server::matrixMsg_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.name);
      stream.next(m.cols);
      stream.next(m.rows);
      stream.next(m.M);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct matrixMsg_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::kombos_server::matrixMsg_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::kombos_server::matrixMsg_<ContainerAllocator>& v)
  {
    s << indent << "name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.name);
    s << indent << "cols: ";
    Printer<int32_t>::stream(s, indent + "  ", v.cols);
    s << indent << "rows: ";
    Printer<int32_t>::stream(s, indent + "  ", v.rows);
    s << indent << "M[]" << std::endl;
    for (size_t i = 0; i < v.M.size(); ++i)
    {
      s << indent << "  M[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.M[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // KOMBOS_SERVER_MESSAGE_MATRIXMSG_H
